unit intrface;

interface
  uses crt,dos,types;
  function getposition(x,y:shortint):integer;
  procedure select(a,b:shortint);
  procedure deselect(a,b:shortint);
  procedure drawboard(pos:position);
  procedure report(white,black,player,k,j:shortint);


implementation

  procedure select(a,b:shortint);
    begin
    if ((a+b) mod 2)=0 then textbackground(4)
                       else textbackground(7);
    textcolor(14);
    gotoxy((a-1)*4+1,(9-b)*2); write('');
    gotoxy(a*4,(9-b)*2); write('');
    gotoxy((a-1)*4+1,(9-b)*2-1); write('');
    gotoxy(a*4,(9-b)*2-1); write('');
    end;

  procedure deselect(a,b:shortint);
    begin
    if ((a+b) mod 2)=0 then textbackground(4)
                       else textbackground(7);
    textcolor(14);
    gotoxy((a-1)*4+1,(9-b)*2); write(' ');
    gotoxy(a*4,(9-b)*2); write(' ');
    gotoxy((a-1)*4+1,(9-b)*2-1); write(' ');
    gotoxy(a*4,(9-b)*2-1); write(' ');
    end;

  procedure up(var x,y:shortint);
    begin
    if (y<8) then begin
      deselect(x,y);
      y:=y+1;
      select(x,y);
    end;
    end;
  procedure down(var x,y:shortint);
    begin
    if (y>1) then begin
      deselect(x,y);
      y:=y-1;
      select(x,y);
    end;
    end;
  procedure left(var x,y:shortint);
    begin
    if (x>1) then begin
      deselect(x,y);
      x:=x-1;
      select(x,y);
    end;
    end;
  procedure right(var x,y:shortint);
    begin
    if (x<8) then begin
      deselect(x,y);
      x:=x+1;
      select(x,y);
    end;
    end;

  function getposition(x,y:shortint): integer;
    var
      key:char;
      reg:registers;
    begin
    select(x,y);
    reg.AH:=$0C;
    reg.AL:=$06;
    reg.DL:=$FF;
    repeat until keypressed;
    repeat
      reg.AH:=$0C;
      reg.AL:=$06;
      reg.DL:=$FF;
      key:=readkey;
      if key=#72 then up(x,y);
      if key=#75 then left(x,y);
      if key=#77 then right(x,y);
      if key=#80 then down(x,y);
      if (key=' ') or (key='q') or (key='n') then break;
    until ((key=#13) and (((x+y) mod 2)=0));
    deselect(x,y);
    getposition:=10*x+y;
    if key='q' then getposition:=0;
    if key='n' then getposition:=-1;
    end;

  procedure changebgcolor(var color:integer);
    begin
    if color=7 then color:=4
               else color:=7;
    end;


  procedure drawboard(pos:position);
    var bgcolor,i,j: integer;
    begin
    window(2,2,33,18);
    textbackground(0);
     clrscr;
    bgcolor:=7; textbackground(bgcolor);
    for i:=0 to 31 do begin
      if i mod 4 = 0 then begin
        for j:=1 to 8 do begin
          write('    '); changebgcolor(bgcolor); textbackground(bgcolor);
        end;
      end;
      if i mod 8 < 4 then begin
        bgcolor:=7; textbackground(bgcolor); write('    ');
        bgcolor:=4; textbackground(bgcolor);
        case pos[29+2*(i mod 4)-i] of
          0: write('    ');
          1: begin textcolor(white); write(' [] ') end;
          2: begin textcolor(white); write(' <> ') end;
          -1: begin textcolor(black); write(' [] ') end;
          -2: begin textcolor(black); write(' <> ') end;
        end;
        end
      else begin
        bgcolor:=4; textbackground(bgcolor);
        case pos[29+2*(i mod 4)-i] of
          0: write('    ');
          1: begin textcolor(white); write(' [] ') end;
          2: begin textcolor(white); write(' <> ') end;
          -1: begin textcolor(black); write(' [] ') end;
          -2: begin textcolor(black); write(' <> ') end;
        end;
        bgcolor:=7; textbackground(bgcolor); write('    ');
      end;
    end;
    end;


  procedure report(white,black,player,k,j:shortint);
    begin
    window(42,2,78,17);
    textbackground(0);
    textcolor(7);
    clrscr;
    writeln('n ... new game');
    writeln('q ... quit');
    writeln; writeln; writeln;
    if player=1 then writeln('white''s turn')
                else writeln('black''s turn');
    writeln('white pieces: ',white);
    writeln('black pieces: ',black);
    if white=0 then writeln('black wins!');
    if black=0 then writeln('white wins!');
    if j=1 then writeln('you should jump!');
    if k=0 then writeln('illegal move!');

    end;
end.